<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Document</title>

    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" />
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <!-- Popper Development version -->
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css" />
    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>
    <!-- Content Header (Page header) -->
    <h1 class="text-center">Quản trị user</h1>

    <!-- Main content -->
    <section class="content">
        <!-- Vùng header -->
        <div class="container">
            <div class="form-group mt-3" style="display: flex; justify-content: space-between;">
                <button class="btn btn-success" id="btn-add-user">
                    <i class="fa fa-plus"></i>&nbsp; New User
                </button>
            </div>
        </div>
        <!-- User Data Table -->
        <div class="container">
            <table class="table table-bordered table-striped table-hover" id="user-table">
                <thead>
                    <tr>
                        <th>STT</th>
                        <th>Full name</th>
                        <th>Phone</th>
                        <th>Status</th>
                        <th>Action</th>
                    </tr>
                </thead>
            </table>
        </div>
        <!-- Vùng Modal -->

        <!-- Create User modal -->
        <div>
            <div id="create-user-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">
                                Create new user
                            </h5>
                            <button class="close" data-dismiss="modal">
                                &times;
                            </button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label>Full name</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-create-fullname" placeholder="Full name"
                                            class="form-control" />
                                    </div>
                                </div>

                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label>Phone</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-create-phone" placeholder="Phone"
                                            class="form-control" />
                                    </div>
                                </div>

                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label>Status</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <select id="select-create-status" class="form-control">
                                            <option value="Level 0">Level 0</option>
                                            <option value="Level 1">Level 1</option>
                                            <option value="Level 2">Level 2</option>
                                            <option value="Level 3">Level 3</option>
                                        </select>
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-secondary" id="btn-create-cancel" data-dismiss="modal">
                                Cancel
                            </button>
                            <button class="btn btn-primary" id="btn-create-user">
                                Create User
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Update user modal -->
        <div>
            <div id="update-user-modal" class="modal fade" tabindex="-1">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">
                                Update a user
                            </h5>
                            <button class="close" data-dismiss="modal">
                                &times;
                            </button>
                        </div>
                        <div class="modal-body">
                            <form>
                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label>Full name</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-update-fullname" placeholder="Full name"
                                            class="form-control" />
                                    </div>
                                </div>

                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label>Phone</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <input type="text" id="input-update-phone" placeholder="Phone"
                                            class="form-control" />
                                    </div>
                                </div>

                                <div class="row form-group">
                                    <div class="col-sm-4">
                                        <label>Status</label>
                                    </div>
                                    <div class="col-sm-8">
                                        <select id="select-update-status" class="form-control">
                                            <option value="Level 0">Level 0</option>
                                            <option value="Level 1">Level 1</option>
                                            <option value="Level 2">Level 2</option>
                                            <option value="Level 3">Level 3</option>
                                        </select>
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-secondary" id="btn-update-cancel" data-dismiss="modal">
                                Cancel
                            </button>
                            <button class="btn btn-primary" id="btn-update-user">
                                Update User
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- Delete confirm modal -->
        <div>
            <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title" id="h5-modal-title">
                                User Delete Confirmation
                            </h5>
                            <button class="close" data-dismiss="modal">
                                &times;
                            </button>
                        </div>
                        <div class="modal-body">
                            <label>Bạn có chắc chắn muốn xóa user này không?</label>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-danger" id="btn-confirm-delete-user">
                                Confirm
                            </button>
                            <button class="btn btn-secondary" data-dismiss="modal">
                                Cancel
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        </div>
    </section>
</body>

</html>

<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    // Biến toàn cục để lưu trữ id user đang đc update or delete. Mặc định = 0;
    var gUserId = 0;

    const gBASE_URL = "http://localhost:8000/api/v1/users";

    // Biến mảng hằng số chứa danh sách tên các thuộc tính
    const gUSER_COLS = [
        "stt",
        "fullName",
        "phone",
        "status",
        "action",
    ];

    // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
    const gSTT_COL = 0;
    const gFULLNAME_COL = 1;
    const gPHONE_COL = 2;
    const gSTATUS_COL = 3;
    const gACTION_COL = 4;

    // Biến toàn cục để hiển lưu STT
    var gSTT = 1;
    // Khai báo DataTable & mapping collumns
    var gUserTable = $("#user-table").DataTable({
        searching: false,
        ordering: false,
        columns: [
            { data: gUSER_COLS[gSTT_COL] },
            { data: gUSER_COLS[gFULLNAME_COL] },
            { data: gUSER_COLS[gPHONE_COL] },
            { data: gUSER_COLS[gSTATUS_COL] },
            { data: gUSER_COLS[gACTION_COL] },
        ],
        columnDefs: [
            {
                // định nghĩa lại cột STT
                targets: gSTT_COL,
                render: function () {
                    return gSTT++;
                },
            },
            {
                // định nghĩa lại cột action
                targets: gACTION_COL,
                defaultContent: `
                    <i class="fas fa-edit edit-user" style = "color: #00a6fb; cursor: pointer" data-toggle="tooltip" data-placement="top" title="Edit"></i>
                    <i class="fa fa-trash delete-user" aria-hidden="true" style = "color: #d00000; cursor: pointer" data-toggle="tooltip" data-placement="top" title="Delete"></i>
                `,
            },
        ],
    });

    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        // thực hiện tải trang
        onPageLoading();
        // 2 - C: gán sự kiện Create - Thêm mới user
        $("#btn-add-user").on("click", function () {
            onBtnAddNewUserClick();
        });
        // 3 - U: gán sự kiện Update - Sửa 1 user
        $("#user-table").on("click", ".edit-user", function () {
            onBtnEditUserClick(this);
        });
        // 4 - D: gán sự kiện Delete - Xóa 1 user
        $("#user-table").on("click", ".delete-user", function () {
            onBtnDeleteUserClick(this);
        });

        // gán sự kiện cho nút Create User (trên modal)
        $("#btn-create-user").on("click", function () {
            onBtnCreateUserClick();
        });

        // gán sự kiện cho nút Update User (trên modal)
        $("#btn-update-user").on("click", function () {
            onBtnUpdateUserClick();
        });
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm thực thi khi trang được load
    function onPageLoading() {
        // 1 - R: Read / Load User to DataTable
        getAllUsers();
    }

    // Hàm xử lý sự kiện khi nút New User đc click
    function onBtnAddNewUserClick() {
        // hiển thị modal lên
        $("#create-user-modal").modal("show");
    }

    // Hàm xử lý sự kiện khi icon edit user trên bảng đc click
    function onBtnEditUserClick(paramBtnEdit) {
        // lưu thông tin UserId đang được edit vào biến toàn cục
        gUserId = getUserIdFromButton(paramBtnEdit);
        // load dữ liệu vào các trường dữ liệu trong modal
        getUserById(gUserId);
    }

    // hàm xử lý sự kiện create user modal click
    function onBtnCreateUserClick() {
        // khai báo đối tượng chứa user data
        var vUserObj = {
            fullName: "",
            phone: "",
            status: "",
        };
        // B1: Thu thập dữ liệu
        getCreateUserData(vUserObj);
        // B2: Validate insert
        var vIsUserValidate = validateUserData(vUserObj);
        if (vIsUserValidate) {
            // B3: insert user
            $.ajax({
                type: "post",
                headers: {
                    "Content-Type": "application/json",
                },
                url: gBASE_URL,
                dataType: "json",
                data: JSON.stringify(vUserObj),
                success: function (paramData) {
                    console.log(paramData);
                    handleInsertUserSuccess();
                },
                error: function (error) {
                    console.log(error);
                },
            });
        }
    }

    // hàm xử lý sự kiện update user modal click
    function onBtnUpdateUserClick() {
        // khai báo đối tượng chứa User data
        var vUserObj = {
            fullName: "",
            phone: "",
            status: "",
        };
        // B1: Thu thập dữ liệu
        getUpdateUserData(vUserObj);
        // B2: Validate update
        var vIsUserValidate = validateUserData(vUserObj);
        if (vIsUserValidate) {
            // B3: update user
            $.ajax({
                type: "put",
                headers: {
                    "Content-Type": "application/json",
                },
                url: gBASE_URL + "/" + gUserId,
                dataType: "json",
                data: JSON.stringify(vUserObj),
                success: function (paramData) {
                    console.log(paramData);
                    // B4: xử lý front-end
                    handleUpdateUserSuccess();
                },
                error: function (error) {
                    console.log(error);
                },
            });
        }
    }

    //hàm thực thi khi nút Delete được ấn
    function onBtnDeleteUserClick(paramBtnEdit) {
        $("#delete-confirm-modal").modal("show");
        gUserId = getUserIdFromButton(paramBtnEdit);
        $(document).on("click", "#btn-confirm-delete-user", function () {
            $.ajax({
                type: "delete",
                url: gBASE_URL + "/" + gUserId,
                dataType: "json",
                success: function (paramData) {
                    console.log(paramData);
                    alert("Xóa thành công");
                    getAllUsers();
                    $("#delete-confirm-modal").modal("hide");
                },
                error: function (error) {
                    console.log(error);
                },
            });
        });
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi api để lấy all danh sách user
    function getAllUsers() {
        $.ajax({
            type: "get",
            url: gBASE_URL,
            dataType: "json",
            success: function (paramData) {
                console.log(paramData);
                loadDataToUserTable(paramData.data);
            },
            error: function (error) {
                console.log(error);
            },
        });
    }
    /** load user array to DataTable
     * in: User array
     * out: User table has data
     */
    function loadDataToUserTable(paramUserArr) {
        gSTT = 1;
        gUserTable.clear();
        gUserTable.rows.add(paramUserArr);
        gUserTable.draw();
    }

    // hàm get User by id
    function getUserById(paramUserId) {
        $.ajax({
            type: "get",
            url: gBASE_URL + "/" + paramUserId,
            dataType: "json",
            success: function (paramData) {
                console.log(paramData);
                showUserDataToModal(paramData.data);
            },
            error: function (error) {
                console.log(error);
            },
        });
        // hiển thị modal lên
        $("#update-user-modal").modal("show");
    }

    // hàm show user obj lên modal
    function showUserDataToModal(paramUser) {
        $("#input-update-fullname").val(paramUser.fullName);
        $("#input-update-phone").val(paramUser.phone);
        $("#select-update-status").val(paramUser.status);
    }

    // hàm thu thập dữ liệu để create user
    function getCreateUserData(paramUserObj) {
        paramUserObj.fullName = $("#input-create-fullname").val().trim();
        paramUserObj.phone = $("#input-create-phone").val().trim();
        paramUserObj.status = $("#select-create-status").val();
    }

    // hàm thu thập dữ liệu để update user
    function getUpdateUserData(paramUserObj) {
        paramUserObj.fullName = $("#input-update-fullname").val().trim();
        paramUserObj.phone = $("#input-update-phone").val().trim();
        paramUserObj.status = $("#select-update-status").val();
    }

    // hàm validate data
    function validateUserData(paramUserObj) {
        if (paramUserObj.fullName == "") {
            alert("Full name cần nhập");
            return false;
        }

        if (paramUserObj.phone == "") {
            alert("Phone cần nhập");
            return false;
        }
        if (validatePhone(paramUserObj.phone) == false) {
            alert("Số điện thoại nhập vào không đúng định dạng!");
            return false;
        }

        return true;
    }

    // hàm xử lý hiển thị front-end khi thêm user thành công
    function handleInsertUserSuccess() {
        alert("Thêm user thành công!");
        getAllUsers();
        resertCreateUserForm();
        $("#create-user-modal").modal("hide");
    }

    // hàm xử lý hiển thị front-end khi sửa user thành công
    function handleUpdateUserSuccess() {
        alert("Sửa user thành công!");
        getAllUsers();
        resertUpdateUserForm();
        $("#update-user-modal").modal("hide");
    }

    // hàm xóa trắng form create user
    function resertCreateUserForm() {
        $("#input-create-fullname").val("");
        $("#input-create-phone").val("");
        $("#select-create-status").val("Level 0");
    }

    // hàm xóa trắng form update User
    function resertUpdateUserForm() {
        $("#input-update-fullname").val("");
        $("#input-update-phone").val("");
        $("#select-update-status").val("Level 0");
    }

    // hàm dựa vào button detail (edit or delete) xác định đc id User
    function getUserIdFromButton(paramButton) {
        var vTableRow = $(paramButton).parents("tr");
        var vUserRowData = gUserTable.row(vTableRow).data();
        return vUserRowData._id;
    }

    //hàm kiểm tra số điện thoại
    function validatePhone(paramPhone) {
        // Số điện thoại phải nhập là số, có dấu + hoặc số 0 ở đầu; độ dài từ 10 đến 12 ký tự

        if (isNaN(paramPhone)) {
            return false;
        }

        if (paramPhone.charAt(0) != "0" && paramPhone.charAt(0) != "+") {
            return false;
        }

        if (paramPhone.length < 10 || paramPhone.length > 12) {
            return false;
        }

        return true;
    }
</script>